import csv
import random
from collections import defaultdict
import numpy as np
import math
import pandas
import pandas as pd
import sys
import time


def Dist(mylist):
     return  set(mylist)

def Ocu(mylist):
    appearances = defaultdict(int)

    for curr in mylist:
        appearances[curr] += 1

    return appearances



def computevariance(freq):
     variance = 0.0
     efx = 0.0
     efx2 = 0.0
     ef = 0.0
     x = 1.0
     for f in freq:
         efx += f * x
         efx2+= f * (x * x)
         ef  += f
         x+=1

     # print "ef: ", ef
     # print "efx2: ",efx2
     # print "efx: ",efx
     # print "((efx/ef) * (efx/ef)): ",(efx/ef)
     variance = (efx2/ef) - ((efx/ef) * (efx/ef))
     return variance


datafromcsv = [[],[]]
Gtable = [[]]
Gtable.append([])
Gtable.append([])
Gtable.append([])





with open("adults.csv",'r') as dest_f:
    data_iter = csv.reader(dest_f,
                           delimiter = ",",
                           quotechar = "'")
    datafromcsv = [data for data in data_iter]

# print datafromcsv[0]
for d in datafromcsv:
    Gtable[0].append(d[2])
    Gtable[1].append(d[3])
    Gtable[2].append(d[4])
    Gtable[3].append(d[5])

# print Gtable[0][1]
# Gtable =  [['Faizan','Amina','Nisa','Salman','Mujtaba','Rehana','Arshad','Amjad','Bashir','Ghulam','Kousar','Noreen','Fatima','Bilal','Rehan','Shakoor','Ali'],
#            ['Malaria','Flu','Flu','Heart','Tumour','Tumour','Malaria','Malaria','Heart','Flu','Heart','Tumour','Tumour','Malaria','Malaria','Heart','Flu']]



# Dist() is a function that counts distinct sensitive 	values in whole table
dsv = Dist(Gtable[3])
dsvCount = dsv.__len__()
print ("distinct values ",dsv)
print ("distict values count ",dsvCount)

# Ocu(A_i^s) function to calculate frequencies of each sensitive attribute value in whole table
frequency = Ocu(Gtable[3])
# print "values frequency ", frequency.items()


decendingorder = sorted(frequency.items(), key=lambda v: v, reverse=True)
decendingvalues = sorted(frequency.values(), key=lambda k: k, reverse=True)

# print "sorted in decending order",decendingorder
# print "sorted values only: ",decendingvalues

# variance = np.var(decendingvalues)
variance = computevariance(decendingvalues)
# print "computed variance ", computevariance(decendingvalues)
# print "computed variance using numpy ", variance







#dsvCount = input("Please Enter the Group's size: ")


dsvCount=0
def getinput():
    global dsvCount
    dsvCount = int(input("Please Enter the Group's size: "))
    if dsvCount<0:
        getinput()
getinput()


'''
miu = 0.3
if dsvCount==3:
   miu=0.3
elif dsvCount>=4 and dsvCount<=7:
   miu=0.5
elif dsvCount>=8 and dsvCount<=11:
   miu=0.6
elif dsvCount>=12 and dsvCount<=15:
   miu=0.7
'''

miu=0.0
if dsvCount>=2 and dsvCount<=3:
    miu=0.5
#    print "check"
elif dsvCount>=4 and dsvCount<=5:
    miu=0.6
elif dsvCount>=6 and dsvCount<=7:
   miu=0.7
elif dsvCount>=8 and dsvCount<=11:
   miu=0.8
elif dsvCount>=12 and dsvCount<=15:
   miu=0.9

threshhold = 0.0
# cmputing threshHold
if dsvCount==2:
    threshhold = miu * 0.25
elif dsvCount==3:
    threshhold = miu * 0.67
elif dsvCount == 4:
    threshhold = miu * 1.25
elif dsvCount==5:
    threshhold = miu * 2.0
elif dsvCount==6:
    threshhold = miu * 2.9
elif dsvCount==7:
    threshhold = miu * 4
elif dsvCount==8:
    threshhold = miu * 5.25
elif dsvCount==9:
    threshhold = miu * 6.67
elif dsvCount==10:
    threshhold = miu * 8.25
elif dsvCount==11:
    threshhold = miu * 10.0
elif dsvCount==12:
    threshhold = miu * 11.916
elif dsvCount==13:
    threshhold = miu * 14.0
elif dsvCount==14:
    threshhold = miu * 16.25
elif dsvCount==15:
    threshhold = miu * 18.66


# cmputing threshHold
# threshhold = miu * variance # value of miu depends on EC size.
print ("threshhold ",threshhold)
# cmputing threshHold
# threshhold = miu * variance
# print "threshhold ",threshhold
totalgroups =(int)(Gtable[3].__len__() / dsvCount)
totalagegroups =(int)(Gtable[0].__len__() / dsvCount)
totalzipgroups =(int)(Gtable[1].__len__() / dsvCount)
totaalcodegroups =(int)(Gtable[2].__len__() / dsvCount)

initgroupsize =(int)(Gtable[2].__len__() / dsvCount)

# separating groups from table
if (Gtable[3].__len__()%dsvCount==0):
   initgroupsize = np.array_split(Gtable[3],totalgroups)
   groups = np.array_split(Gtable[3],totalgroups)
   agegroups = np.array_split(Gtable[0], totalagegroups)
   zipgroups = np.array_split(Gtable[1], totalzipgroups)
   codegroups = np.array_split(Gtable[2], totaalcodegroups)
else:
    limit = Gtable[3].__len__()%dsvCount
    initgroupsize = np.array_split(Gtable[3][:Gtable[3].__len__()-limit],totalgroups)
    initgroupsize.append(Gtable[3][(0-limit):])

    groups = np.array_split(Gtable[3][:Gtable[3].__len__()-limit],totalgroups)
    groups.append(Gtable[3][(0-limit):])

    agegroups = np.array_split(Gtable[0][:Gtable[0].__len__() - limit], totalgroups)
    agegroups.append(Gtable[0][(0 - limit):])

    zipgroups = np.array_split(Gtable[1][:Gtable[1].__len__() - limit], totalgroups)
    zipgroups.append(Gtable[1][(0 - limit):])

    codegroups = np.array_split(Gtable[2][:Gtable[2].__len__() - limit], totalgroups)
    codegroups.append(Gtable[2][(0 - limit):])
    # print "final group",Gtable[3][(0-limit):]

# calculating variance for EC or groups one by one
# varianceForGroups = []

def calculatevarianceforeachgroup():
        vr = []
        for group in groups:
            groupfreq = Ocu(group)
            # print groupfreq.viewitems()
            decendingGroupvalues = sorted(groupfreq.values(), key=lambda k: k, reverse=True)
            # print decendingGroupvalues
            # groupvariance = np.var(decendingGroupvalues)
            groupvariance = computevariance(decendingGroupvalues)
            vr.append(groupvariance)
        return vr
varianceForGroups = calculatevarianceforeachgroup()
print ("Each Groups varriance list: ",varianceForGroups)

'''
def Dist(group):
    dv=[]
    for group in groups:
        groupdv=Dist(group)
        dv.append(groupdv)
    return set(group)

dsv = Dist(Gtable[3])
dvCount = dsv.__len__()
print "Each Groups varriance list: ",
# print "all groups: ",groups
'''


def getMostFreqRecord(groupforMFV):
    groupfr = Ocu(groupforMFV)
    mfv = sorted(groupfr.items(), key=lambda v: v, reverse=True)
    return mfv
def checkifvalueexist(mfvCurrent, mfvBroken):
    for mfvC in mfvCurrent:
        # print "dat",mfvC[0],mfvBroken
        if(mfvBroken==mfvC[0]):
            return True
    return False

def findindexof(grpp,inthisgrp):
    indx = 0
    for g in inthisgrp:
        if(g==grpp):
            return indx
            break
        indx +=1


def checkConditionForswaping(mfvCurrent, mfvBroken):
    while(mfvBroken.__len__()!=0):
        valueAlreadyexist = checkifvalueexist(mfvCurrent, mfvBroken[0][0])
        # print "cur",mfvCurrent
        # print "brok",mfvBroken
        if (valueAlreadyexist):
            # print "remo", mfvBroken[0]
            mfvBroken.remove(mfvBroken[0])
            # checkConditionForswaping(mfvCurrent, mfvBroken)
        else:
            # print "brok final", mfvBroken
            return mfvBroken
totalnoofgroupswhereswapping = 0
def swaplastgroup(lastgroup,secndlastgroup):
    global totalnoofgroupswhereswapping
    lastgp = getMostFreqRecord(lastgroup)
    secndlastgp = getMostFreqRecord(secndlastgroup)
    isswappingpossible = False
    test = "null"
    for gp in secndlastgp:
        if(lastgp[0][0]!=gp[0]):
            test = "dosntexist"
        else:
            test = "exist"

    if(test=="dosntexist"):
        ind = 0
        for i in lastgp:
            test2  = "null"
            for gp in lastgp:
                if (secndlastgp[ind][0] != gp[0]):
                    test2 = "dosntexist"
                else:
                    test2 = "exist"
            if test2=="dosntexist":
                # print ""
                # print "my last group ",groups[-1]
                # print "my last group 2 ",lastgp[0][0]
                # print "my last group 2 ",type(groups[-1])
                index1 = findindexof(lastgp[0][0],groups[-1])
                index2 = findindexof(secndlastgp[ind][0],groups[-2])
                # index1 = groups[-1].index(lastgp[0][0])
                # index2 = groups[-2].index(secndlastgp[ind][0])
                groups[-2][index2], groups[-1][index1] = groups[-1][index1], groups[-2][index2]
                agegroups[-2][index2], agegroups[-1][index1] = agegroups[-1][index1], agegroups[-2][index2]
                zipgroups[-2][index2], zipgroups[-1][index1] = zipgroups[-1][index1], zipgroups[-2][index2]
                codegroups[-2][index2], codegroups[-1][index1] = codegroups[-1][index1], codegroups[-2][index2]
                totalnoofgroupswhereswapping += 1
                break
        ind +=1

    # print "llast 2 groups",groups[-2][index2]," ,, ",groups[-1][index1]


def swappingwithvariance(currentgroupindex):
 global varianceForGroups,totalnoofgroupswhereswapping


 while (True):
        # print "length of varriance forgroup: ",currentgroupindex,varianceForGroups.__len__()
        if (currentgroupindex==varianceForGroups.__len__()):
            # print "finished"
            # print varianceForGroups
            # print groups
            break
            # return
        if (varianceForGroups[currentgroupindex] < threshhold):
            # print "variance for current: ",varianceForGroups[currentgroupindex]
            brokengroupindex = currentgroupindex + 1
            status = "loopnotbroken"
            if (brokengroupindex == varianceForGroups.__len__()):
              if(groups[-1].__len__()>0):
                swaplastgroup(groups[-1],groups[-2])
                varianceForGroups = calculatevarianceforeachgroup()
                print ("variance for last group: ",varianceForGroups[currentgroupindex])
                if(varianceForGroups[currentgroupindex] < threshhold):
                    status = "loopnotbroken"
                else:
                    break
              else:
                  status = "loopnotbroken"
            else:
                while (brokengroupindex != varianceForGroups.__len__()):
                    if (varianceForGroups[brokengroupindex] > threshhold):
                        status = "broken"
                        break
                    brokengroupindex += 1
            # print status
            if (status == "broken"):
                mfvCurrent = getMostFreqRecord(groups[currentgroupindex])
                mfvBroken = getMostFreqRecord(groups[brokengroupindex])
                whattodo = checkConditionForswaping(mfvCurrent, mfvBroken)
                # print " non", whattodo
                if (whattodo.__len__() > 0):  # swapp them
                    # print "indexofc: ", mfvCurrent[0][0], groups[currentgroupindex], groups[currentgroupindex].tolist().index(mfvCurrent[0][0])
                    # print "indexof: ", whattodo[0][0], groups[brokengroupindex], groups[brokengroupindex].tolist().index(whattodo[0][0])
                    index1 = groups[currentgroupindex].tolist().index(mfvCurrent[0][0])
                    index2 = groups[brokengroupindex].tolist().index(whattodo[0][0])
                    groups[currentgroupindex][index1], groups[brokengroupindex][index2] = groups[brokengroupindex][index2],groups[currentgroupindex][index1]
                    agegroups[currentgroupindex][index1], agegroups[brokengroupindex][index2] = agegroups[brokengroupindex][index2], agegroups[currentgroupindex][index1]
                    zipgroups[currentgroupindex][index1], zipgroups[brokengroupindex][index2] = zipgroups[brokengroupindex][index2], zipgroups[currentgroupindex][index1]
                    codegroups[currentgroupindex][index1], codegroups[brokengroupindex][index2] = codegroups[brokengroupindex][index2], codegroups[currentgroupindex][index1]
                    totalnoofgroupswhereswapping +=1
                    varianceForGroups = calculatevarianceforeachgroup()
                    # print varianceForGroups
                    # print groups

                    if (varianceForGroups[currentgroupindex] > threshhold):
                        currentgroupindex += 1
                        # printProgressBar(currentgroupindex - groups.__len__(), groups.__len__(), " Completed ")
                        # print "percent completed: ",currentgroupindex*100/groups.__len__()
                        # swappingwithvariance(currentgroupindex)
                    else:
                        pass
                        # swappingwithvariance(currentgroupindex)
                elif (whattodo.__len__() == 0):  # add noise
                    pass

            else:
                # print groups[currentgroupindex]
                # print agegroups[currentgroupindex]
                # print zipgroups[currentgroupindex]
                # print codegroups[currentgroupindex]
                # print "index1",currentgroupindex
                indexforcurrentgrp = 0
                check = "-1"
                for grp in dsv:
                    for cgrp in groups[currentgroupindex]:
                      if grp == cgrp:
                        check = "found"
                        break;
                      else:
                          check = "not found"
                    if check == "not found":
                        groups[currentgroupindex] = np.append(groups[currentgroupindex], grp)
                        agegroups[currentgroupindex] = np.append(agegroups[currentgroupindex], random.choice(agegroups[currentgroupindex]))
                        zipgroups[currentgroupindex] = np.append(zipgroups[currentgroupindex], random.choice(zipgroups[currentgroupindex]))
                        codegroups[currentgroupindex] = np.append(codegroups[currentgroupindex], random.choice(codegroups[currentgroupindex]))
                        varianceForGroups = calculatevarianceforeachgroup()
                        # print "modified",groups
                        # swappingwithvariance(currentgroupindex)
                        break

        else:
            currentgroupindex += 1
            # printProgressBar(currentgroupindex - groups.__len__(),groups.__len__()," Completed ")
            # print "percent completed: ", currentgroupindex * 100 / groups.__len__()
            # swappingwithvariance(currentgroupindex)
        cli_progress_test(currentgroupindex * 100 / groups.__len__())


def cli_progress_test(end_val: object, bar_length: object = 100) -> object:
    end_val=int()
    bar_length = int()

    for i in range(0, end_val):
        percent = float(i) / end_val
        hashes = '#' * int(round(percent * bar_length))
        spaces = ' ' * (bar_length - len(hashes))
        sys.stdout.write("\rPercent: [{0}] {1}%".format(hashes + spaces, int(round(percent * 100))))
        sys.stdout.flush()


def Normalization(varianceForGroups):
      currentgroupindex = 0
      swappingwithvariance(currentgroupindex)





# swapping algo
Normalization(varianceForGroups)
print ("number of groups",groups.__len__())
# print "noise "

datatobewriten = [[]]
datatobewriten.append([])
datatobewriten.append([])
datatobewriten.append([])


for grop in agegroups:
    groppint = []
    for g in grop:
        groppint.append(str(g))
    groppint.sort()
    for g in grop:
        datatobewriten[0].append(str(groppint[0])+"-"+str(groppint[-1]))

'''
for grop in zipgroups:
    for g in grop:
        datatobewriten[1].append(g)

for grop in codegroups:
    for g in grop:
        datatobewriten[2].append(g)
'''
for grop in zipgroups:
    groppint = []
    for g in grop:
        groppint.append(str(g))
    groppint.sort()
    for g in grop:
        datatobewriten[1].append(str(groppint[0])+"-"+str(groppint[-1]))

#for grop in zipgroups:
#    for g in grop:
#        datatobewriten[1].append(g)

for grop in codegroups:
    groppint = []
    for g in grop:
        groppint.append(str(g))
    groppint.sort()
    for g in grop:
        datatobewriten[2].append(str(groppint[0])+"-"+str(groppint[-1]))

index = 0
groupsquere = 0
totalnoiseadded = 0
for grop in groups:
    print ("Group No. ",index+1," noise added",grop.__len__()-initgroupsize[index].__len__())
    groupsquere  +=((grop.__len__())*(grop.__len__())) #DCP
    totalnoiseadded +=grop.__len__()-initgroupsize[index].__len__()
    index+=1
    for g in grop:
      datatobewriten[3].append(g)

data_to_write = zip(*datatobewriten)
with open("Adults1Final.txt","w+") as my_csv:
    csvWriter = csv.writer(my_csv,delimiter=',')
    csvWriter.writerows(data_to_write)


df1 = pd.read_csv("Adults1Final.txt")
#5 df1['group_number'] = df1.groupby(['33-45'])['LOW'].ngroup()
df1['group_number'] = df1.groupby(['33-age'])['symptoms'].ngroup()
#df1['group_number'] = df1.groupby(['33-age'])['symptoms'].ngroup()
# 5     df1.drop('a-sympti', axis=1, inplace=True)
df1.drop('symptoms', axis=1, inplace=True)
#df1.drop('symptoms', axis=1, inplace=True)
print(df1)
df1.to_csv('qausi.csv')

df = pd.read_csv("Adults1Final.txt")
#5         df['group_number'] = df.groupby(['33-45'])['a-sympti'].ngroup()
df['group_number'] = df.groupby(['33-age'])['symptoms'].ngroup()
df.drop(df.columns[[0,1,2]], axis = 1, inplace = True)
df.to_csv('senstive.csv')

print ("Total No of groups: ",groups.__len__())
print ("Total No of noise: ",totalnoiseadded)
print ("Total No of groups where swapping occured: ",totalnoofgroupswhereswapping )
print ("Group Squere Sum: ",groupsquere)

df = pd.read_csv("Adults1Final.txt")
df.drop(df.columns[[0,1,2,3]], axis = 1, inplace = True)
df.to_csv('Adults1Final.txt')


'''
df1 = pd.read_csv("qausi.csv")
df1['nid'] = df1.groupby(['symptoms'])['bid'].ngroup()
df1.to_csv('qausi.csv')
'''


